<template>
  <div class="col s12 m6">
    <div>
      <div class="page-subtitle">
        <h4>{{ 'Edit' | localization }}</h4>
      </div>

      <form @submit.prevent="submitHandler">
        <div class="input-field" >
          <select name="category" class="categories" v-model="categoryId">
            <option
                v-for="category in categories"
                :key="category.id"
                :value="category.id"
            >
              {{ category.name }}
            </option>
          </select>
          <label>{{ 'Select category' | localization }}</label>
        </div>

        <div class="input-field">
          <input
              id="name"
              type="text"
              v-model.trim="name"
              :class="{invalid: $v.name.$dirty && !$v.name.required}"
          >
          <label for="name">{{ 'Title' | localization }}</label>

          <span v-if="$v.name.$dirty && !$v.name.required" class="helper-text invalid">
            {{ 'Enter title' | localization }}
          </span>

        </div>

        <div class="input-field">
          <input
              id="limit"
              type="number"
              v-model="limit"
              :class="{invalid: $v.name.$dirty && !$v.name.minValue}"
          >
          <label for="limit">{{ 'Limit' | localization }}</label>

          <span v-if="$v.limit.$dirty && !$v.limit.minValue" class="helper-text invalid">
            {{ 'Limit must be numeric' | localization }}
          </span>

        </div>

        <button class="btn waves-effect waves-light" type="submit">
          {{ 'Update' | localization }}
          <i class="material-icons right">send</i>
        </button>
      </form>
    </div>
  </div>
</template>

<script>
import {required, minValue} from 'vuelidate/lib/validators';

export default {
  name: "Editing",
  props: ['categories'],
  data: () => ({
    select: null,
    categoryId: null,
    name: '',
    limit: ''
  }),
  created() {
    const {id, name, limit} = this.categories[0];
    this.categoryId = id;
    this.name = name;
    this.limit = limit;
  },
  validations: {
    name: {required},
    limit: {minValue: minValue(1)}
  },
  watch: {
    categoryId(value) {
      const {name, limit} = this.categories.find(c => c.id === value);
      this.name = name;
      this.limit = limit;
    }
  },
  mounted() {
    const categoriesSelect = document.querySelector('select.categories');
    this.select = M.FormSelect.init(categoriesSelect);
    M.updateTextFields();
  },
  beforeDestroy() {
    if (this.select && this.select.destroy) {
      this.select.destroy();
    }
  },
  methods: {
    async submitHandler() {
      if (this.$v.$invalid) {
        this.$v.$touch();
        return false;
      }

      const formData = {
        name: this.name,
        limit: this.limit,
        id: this.categoryId
      };

      try {
        this.$store.dispatch('updateCategory', formData);
        this.$emit('updated', formData);
      } catch (e) {}
    }
  }
}
</script>

<style scoped>

</style>